#!/bin/sh
# Exit the script if any command fails
set -e

if [ "$1" = 'start' ]; then

  BROWSER_FOLDER=/usr/share/nginx/html

  if [ "$WEBCONTEXT" = '/' ]; then
      targetPath="$BROWSER_FOLDER/assets/configurations"
  else
      mkdir -p /tmp/"$WEBCONTEXT"/
      mv -v $BROWSER_FOLDER/* /tmp/"$WEBCONTEXT"/
      rm -rf $BROWSER_FOLDER/*
      mkdir -p $BROWSER_FOLDER/"$WEBCONTEXT"/
      mv -v /tmp/"$WEBCONTEXT"/* $BROWSER_FOLDER/"$WEBCONTEXT"/
      rm -rf /tmp/"$WEBCONTEXT"
      targetPath="$BROWSER_FOLDER/$WEBCONTEXT/assets/configurations"
  fi

  jsonRuntimeFilePath="/usr/share/nginx/environments/environment.runtime.json"
  mkdir -p "$targetPath"

  # Inject environment config to the angular dist assets/ folder
  if [ -e $jsonRuntimeFilePath ]; then
    jq '.dummyClientSecret = $value' --arg value "$CLIENT_SECRET" $jsonRuntimeFilePath >/usr/share/nginx/environments/tmp.$$.json \
    && cp /usr/share/nginx/environments/tmp.$$.json "$targetPath/environment.runtime.json" \
    && rm -rf /usr/share/nginx/environments/tmp.$$.json
  fi

  # Inject BASE_HREF to index.html <base href/> tag
  chmod a+x $BROWSER_FOLDER/patch-base-href.sh
  $BROWSER_FOLDER/patch-base-href.sh $BROWSER_FOLDER $BASE_HREF

  # Start http server
  exec nginx -g 'daemon off;'
fi

# Used to run a custom command on container start
exec "$@"
